# pylint: disable=C0111

# This is here so configs done via the GUI are still loaded.
# Remove it to not load settings done via the GUI.
config.load_autoconfig(False)

# Aliases for commands. The keys of the given dictionary are the
# aliases, while the values are the commands they map to.
# Type: Dict
c.aliases = {
    'w': 'session-save',
    'q': 'close',
    'qa': 'quit',
    'wq': 'quit --save',
    'wqa': 'quit --save'
}

# Time interval (in milliseconds) between auto-saves of
# config/cookies/etc.
# Type: Int
c.auto_save.interval = 15000

# Enable smooth scrolling for web pages. Note smooth scrolling does not
# work with the `:scroll-px` command.
# Type: Bool
c.scrolling.smooth = True

c.spellcheck.languages = [
    'en-US',
    'fr-FR',
]

config.source('completion.py')
config.source('content.py')
config.source('downloads.py')
config.source('editor.py')
config.source('keybinds.py')
config.source('fileselect.py')
config.source('hints.py')
config.source('input.py')
config.source('statusbar.py')
config.source('tabs.py')
config.source('url.py')
config.source('window.py')
config.source('nord.py')
